#include "cxx-nodecl.h"
#include "cxx-nodecl-deep-copy.h"
#include "cxx-symbol-deep-copy.h"
#include "cxx-cexpr-deep-copy.h"
#include "cxx-nodecl-output.h"
#include "cxx-scope.h"
#include "cxx-typeutils.h"
#include "cxx-utils.h"
#include "mem.h"
/* Autogenerated file. DO NOT MODIFY. */
/* Changes in nodecl-generator.py or cxx-nodecl.def will overwrite this file */

extern nodecl_t nodecl_deep_copy_context(nodecl_t n, const decl_context_t* new_decl_context, 
   symbol_map_t* symbol_map,
   symbol_map_t** synth_symbol_map,
   nodecl_deep_copy_map_t* nodecl_deep_copy_map,
   symbol_deep_copy_map_t* symbol_deep_copy_map);
extern nodecl_t nodecl_deep_copy_function_code(nodecl_t n, const decl_context_t* new_decl_context, 
   symbol_map_t* symbol_map,
   symbol_map_t** synth_symbol_map,
   nodecl_deep_copy_map_t* nodecl_deep_copy_map,
   symbol_deep_copy_map_t* symbol_deep_copy_map);

extern void nodecl_deep_copy_map_add(
   nodecl_deep_copy_map_t* nodecl_deep_copy_map,
   nodecl_t orig,
   nodecl_t copied);

nodecl_t nodecl_deep_copy_rec(nodecl_t n, const decl_context_t* new_decl_context,
   symbol_map_t* symbol_map,
   symbol_map_t** synth_symbol_map,
   nodecl_deep_copy_map_t* nodecl_deep_copy_map,
   symbol_deep_copy_map_t* symbol_deep_copy_map)
{
    *synth_symbol_map = symbol_map;

    if (nodecl_is_null(n))
        return nodecl_null();
    nodecl_t result;
    switch (nodecl_get_kind(n))
    {
        case AST_NODE_LIST:
        {
          int num_items = 0;
          result = nodecl_null();
          nodecl_t* list = nodecl_unpack_list(n, &num_items);
          int i;
          for (i = 0; i < num_items; i++)
          {
                  result = nodecl_append_to_list(result, nodecl_deep_copy_rec(list[i], new_decl_context,
                          *synth_symbol_map, synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map));
          }
          DELETE(list);
          break;
        }

       case NODECL_STRUCTURED_VALUE_PARENTHESIZED:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value_parenthesized(location);
       break;
       }
       case NODECL_STRUCTURED_VALUE_BRACED_TYPECAST:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value_braced_typecast(location);
       break;
       }
       case NODECL_STRUCTURED_VALUE_BRACED_IMPLICIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value_braced_implicit(location);
       break;
       }
       case NODECL_STRUCTURED_VALUE_COMPOUND_LITERAL:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value_compound_literal(location);
       break;
       }
       case NODECL_STRUCTURED_VALUE_FORTRAN_TYPESPEC_ARRAY_CONSTRUCTOR:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value_fortran_typespec_array_constructor(location);
       break;
       }
       case NODECL_CXX_DEP_TEMPLATE_ID:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
template_parameter_list_t* template_parameters = nodecl_get_template_parameters(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_template_id(child_0, text, template_parameters, location);
nodecl_set_symbol(result, symbol);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_CXX_DEP_NAME_CONVERSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = _nodecl_wrap(ast_copy(nodecl_get_ast(nodecl_get_child(n, 2))));
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_name_conversion(child_0, child_1, child_2, location);
nodecl_set_symbol(result, symbol);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_CXX_DEP_DECLTYPE:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_decltype(type, location);
       break;
       }
       case NODECL_TEXT:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_text(text, location);
       break;
       }
       case NODECL_CUDA_KERNEL_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cuda_kernel_call(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PRAGMA_CUSTOM_DIRECTIVE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_custom_directive(child_0, child_1, text, location);
       break;
       }
       case NODECL_PRAGMA_CONTEXT:
       {
const decl_context_t* decl_context = nodecl_get_decl_context(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_context(decl_context, location);
       break;
       }
       case NODECL_RANGE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_range(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_OPEN_M_P_SECTIONS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_sections(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_MASTER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_master(child_0, location);
       break;
       }
       case NODECL_PRAGMA_CUSTOM_LINE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_custom_line(child_0, child_1, child_2, text, location);
       break;
       }
       case NODECL_GCC_BUILTIN_VA_ARG:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_gcc_builtin_va_arg(child_0, child_1, type, location);
       break;
       }
       case NODECL_OPEN_M_P_CRITICAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_critical(child_0, child_1, location);
       break;
       }
       case NODECL_PRAGMA_CUSTOM_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_custom_statement(child_0, child_1, text, location);
       break;
       }
       case NODECL_TOP_LEVEL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_top_level(child_0, location);
       break;
       }
       case NODECL_INTEL_ASSUME_ALIGNED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_intel_assume_aligned(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_INTEL_ASSUME:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_intel_assume(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_OMP_SS_REGISTER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_register(child_0, location);
       break;
       }
       case NODECL_OMP_SS_UNREGISTER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_unregister(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_SIMD_FOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_simd_for(child_0, child_1, location);
       break;
       }
       case NODECL_ANALYSIS_PHI:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_phi(child_0, type, location);
       break;
       }
       case NODECL_ANALYSIS_RANGE_UNION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_range_union(child_0, child_1, type, location);
       break;
       }
       case NODECL_ANALYSIS_RANGE_INTERSECTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_range_intersection(child_0, child_1, type, location);
       break;
       }
       case NODECL_ANALYSIS_RANGE_SUB:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_range_sub(child_0, child_1, type, location);
       break;
       }
       case NODECL_ANALYSIS_EMPTY_RANGE:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_empty_range(location);
       break;
       }
       case NODECL_ANALYSIS_MINUS_INFINITY:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_minus_infinity(type, cval, location);
       break;
       }
       case NODECL_ANALYSIS_PLUS_INFINITY:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_plus_infinity(type, cval, location);
       break;
       }
       case NODECL_ANALYSIS_MINIMUM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_minimum(child_0, type, location);
       break;
       }
       case NODECL_ANALYSIS_MAXIMUM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_maximum(child_0, type, location);
       break;
       }
       case NODECL_STRING_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_string_literal(type, cval, location);
nodecl_set_text(result, text);
       break;
       }
       case NODECL_OPEN_M_P_SCHEDULE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_schedule(child_0, text, location);
       break;
       }
       case NODECL_OPEN_M_P_DIST_SCHEDULE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_dist_schedule(child_0, text, location);
       break;
       }
       case NODECL_OMP_SS_TARGET_DECLARATION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_target_declaration(child_0, child_1, location);
       break;
       }
       case NODECL_GCC_ASM_DEFINITION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_gcc_asm_definition(child_0, child_1, child_2, child_3, text, location);
       break;
       }
       case NODECL_OPEN_M_P_TASKWAIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_taskwait(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TASKGROUP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_taskgroup(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_FLUSH_MEMORY:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_flush_memory(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_BARRIER_FULL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_barrier_full(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_BARRIER_SIGNAL:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_barrier_signal(location);
       break;
       }
       case NODECL_OPEN_M_P_BARRIER_WAIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_barrier_wait(location);
       break;
       }
       case NODECL_OPEN_M_P_PARALLEL_SIMD_FOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_parallel_simd_for(child_0, child_1, location);
       break;
       }
       case NODECL_PRAGMA_CUSTOM_DECLARATION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_custom_declaration(child_0, child_1, child_2, child_3, symbol, text, location);
       break;
       }
       case NODECL_LOOP_CONTROL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_loop_control(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_UNBOUNDED_LOOP_CONTROL:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_unbounded_loop_control(location);
       break;
       }
       case NODECL_SYMBOL:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_symbol(symbol, location);
nodecl_set_type(result, type);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_FORTRAN_IO_SPEC:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_io_spec(child_0, text, location);
       break;
       }
       case NODECL_OPEN_M_P_SINGLE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_single(child_0, child_1, location);
       break;
       }
       case NODECL_ALIGNED_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_aligned_flag(location);
       break;
       }
       case NODECL_ALIGNMENT_INFO:
       {
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_alignment_info(cval, location);
       break;
       }
       case NODECL_IN_PLACE_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_in_place_flag(location);
       break;
       }
       case NODECL_ON_TOP_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_on_top_flag(location);
       break;
       }
       case NODECL_EVICT_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_evict_flag(location);
       break;
       }
       case NODECL_RELAXED_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_relaxed_flag(location);
       break;
       }
       case NODECL_NONTEMPORAL_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_nontemporal_flag(location);
       break;
       }
       case NODECL_HAS_BEEN_DEFINED_FLAG:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_has_been_defined_flag(location);
       break;
       }
       case NODECL_FUNCTION_CODE:
       {
          result = nodecl_deep_copy_function_code(n, new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
          nodecl_deep_copy_map_add(nodecl_deep_copy_map, n, result);
          return result;
       }
       case NODECL_OMP_SS_TASK_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_task_call(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_OPEN_M_P_TASKYIELD:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_taskyield(location);
       break;
       }
       case NODECL_OPEN_M_P_WORKSHARE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_workshare(child_0, child_1, location);
       break;
       }
       case NODECL_PRAGMA_CLAUSE_ARG:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_clause_arg(text, location);
       break;
       }
       case NODECL_OPEN_M_P_SIMD_FUNCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_simd_function(child_0, child_1, location);
       break;
       }
       case NODECL_MEMBER_INIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_member_init(child_0, symbol, location);
       break;
       }
       case NODECL_IMPLICIT_MEMBER_INIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_implicit_member_init(child_0, symbol, location);
       break;
       }
       case NODECL_OPEN_M_P_ATOMIC:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_atomic(child_0, child_1, location);
       break;
       }
       case NODECL_CXX_CLASS_MEMBER_ACCESS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_class_member_access(child_0, child_1, type, location);
nodecl_set_text(result, text);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_ARROW:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_arrow(child_0, child_1, type, text, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_DOT_PTR_MEMBER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dot_ptr_member(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_ARROW_PTR_MEMBER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_arrow_ptr_member(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_SIZEOF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_sizeof(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_SIZEOF_PACK:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_sizeof_pack(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_ALIGNOF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_alignof(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_POSTFIX_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_postfix_initializer(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_CAST:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_cast(child_0, type, text, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_EXPLICIT_TYPE_CAST:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_explicit_type_cast(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_DEP_FUNCTION_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_function_call(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_DEP_NEW:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_new(child_0, child_1, child_2, type, text, location);
       break;
       }
       case NODECL_CXX_NOEXCEPT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_noexcept(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CXX_LAMBDA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_lambda(child_0, symbol, type, location);
       break;
       }
       case NODECL_CXX_ALIGNAS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_alignas(child_0, type, location);
       break;
       }
       case NODECL_STRUCTURED_VALUE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_structured_value(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_FORTRAN_DATA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_data(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_EQUIVALENCE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_equivalence(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_BOZ_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_boz_literal(type, text, cval, location);
       break;
       }
       case NODECL_FORTRAN_BIND_C:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_bind_c(child_0, location);
       break;
       }
       case NODECL_FORTRAN_HOLLERITH:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_hollerith(type, text, cval, location);
       break;
       }
       case NODECL_FORTRAN_USE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_use(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_USE_ONLY:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_use_only(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_SIMD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_simd(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_ACTUAL_ARGUMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_actual_argument(child_0, location);
nodecl_set_text(result, text);
       break;
       }
       case NODECL_FORTRAN_NOT_PRESENT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_not_present(location);
       break;
       }
       case NODECL_OPEN_M_P_FLUSH_AT_ENTRY:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_flush_at_entry(location);
       break;
       }
       case NODECL_OPEN_M_P_FLUSH_AT_EXIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_flush_at_exit(location);
       break;
       }
       case NODECL_OPEN_M_P_NO_FLUSH:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_no_flush(location);
       break;
       }
       case NODECL_DEFAULT_ARGUMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_default_argument(child_0, location);
       break;
       }
       case NODECL_CXX_MEMBER_INIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_member_init(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_OPEN_M_P_SECTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_section(child_0, location);
       break;
       }
       case NODECL_COMPOUND_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_compound_statement(child_0, child_1, location);
       break;
       }
       case NODECL_EMPTY_STATEMENT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_empty_statement(location);
       break;
       }
       case NODECL_EXPRESSION_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_expression_statement(child_0, location);
       break;
       }
       case NODECL_DO_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_do_statement(child_0, child_1, location);
       break;
       }
       case NODECL_WHILE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_while_statement(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_FOR_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_for_statement(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_IF_ELSE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_if_else_statement(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_LABELED_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_labeled_statement(child_0, symbol, location);
       break;
       }
       case NODECL_SWITCH_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_switch_statement(child_0, child_1, location);
       break;
       }
       case NODECL_DEFAULT_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_default_statement(child_0, location);
       break;
       }
       case NODECL_CASE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_case_statement(child_0, child_1, location);
       break;
       }
       case NODECL_BREAK_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_break_statement(child_0, location);
       break;
       }
       case NODECL_CONTINUE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_continue_statement(child_0, location);
       break;
       }
       case NODECL_GOTO_STATEMENT:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_goto_statement(symbol, location);
       break;
       }
       case NODECL_RETURN_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_return_statement(child_0, location);
       break;
       }
       case NODECL_ERR_STATEMENT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_err_statement(location);
       break;
       }
       case NODECL_OBJECT_INIT:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_object_init(symbol, location);
       break;
       }
       case NODECL_GCC_ASM_SPEC:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_gcc_asm_spec(text, location);
       break;
       }
       case NODECL_CONTEXT:
       {
          result = nodecl_deep_copy_context(n, new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
          nodecl_deep_copy_map_add(nodecl_deep_copy_map, n, result);
          return result;
       }
       case NODECL_OPEN_M_P_PARALLEL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_parallel(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_FUNCTION_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_function_call(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ARRAY_SUBSCRIPT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_array_subscript(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CLASS_MEMBER_ACCESS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_class_member_access(child_0, child_1, child_2, type, location);
nodecl_set_text(result, text);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PLUS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_plus(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_NEG:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_neg(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MUL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_mul(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_POWER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_power(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DIV:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_div(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MOD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_mod(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ADD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_add(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MINUS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_minus(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_CONCAT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_concat(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_EQUAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_equal(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DIFFERENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_different(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_LOWER_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_lower_than(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_LOWER_OR_EQUAL_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_lower_or_equal_than(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_GREATER_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_greater_than(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_GREATER_OR_EQUAL_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_greater_or_equal_than(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_LOGICAL_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_logical_not(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_LOGICAL_AND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_logical_and(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_LOGICAL_OR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_logical_or(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_not(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_AND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_and(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_OR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_or(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_XOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_xor(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_SHL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_shl(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ARITHMETIC_SHR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_arithmetic_shr(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_SHR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_shr(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PARENTHESIZED_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_parenthesized_expression(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DEREFERENCE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_dereference(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_COMPOUND_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_compound_expression(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_SUBSCRIPT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_subscript(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_ADD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_add(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_FMADD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_fmadd(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MINUS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_minus(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_FMMINUS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_fmminus(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MUL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mul(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_DIV:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_div(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_RCP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_rcp(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MOD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mod(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_NEG:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_neg(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_SQRT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_sqrt(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_RSQRT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_rsqrt(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_REDUCTION_ADD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_reduction_add(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_REDUCTION_MINUS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_reduction_minus(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_REDUCTION_MUL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_reduction_mul(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_EQUAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_equal(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_DIFFERENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_different(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOWER_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_lower_than(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOWER_OR_EQUAL_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_lower_or_equal_than(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_GREATER_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_greater_than(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_GREATER_OR_EQUAL_THAN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_greater_or_equal_than(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOGICAL_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_logical_not(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOGICAL_AND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_logical_and(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOGICAL_OR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_logical_or(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_not(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_AND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_and(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_OR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_or(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_XOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_xor(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_SHL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_shl(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_ARITHMETIC_SHR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_arithmetic_shr(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_BITWISE_SHR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_bitwise_shr(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_ALIGN_RIGHT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_align_right(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_assignment(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_STORE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_store(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_SCATTER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_scatter(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOAD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_load(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_GATHER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_gather(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_PROMOTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_promotion(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_PREFETCH:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_prefetch(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LITERAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_literal(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LANE_ID:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_lane_id(type, cval, location);
       break;
       }
       case NODECL_VECTOR_CONVERSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_conversion(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_CAST:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_cast(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_FUNCTION_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_function_call(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_FABS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_fabs(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_SINCOS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_sincos(child_0, child_1, child_2, child_3, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_CONVERSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_conversion(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_not(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_AND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_and(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_OR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_or(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_XOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_xor(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_AND_1_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_and_1_not(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_MASK_AND_2_NOT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_mask_and_2_not(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_LOOP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_loop(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ERR_EXPR:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_err_expr(location);
       break;
       }
       case NODECL_CONVERSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_conversion(child_0, type, location);
nodecl_set_text(result, text);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DUMMY:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_dummy(type, location);
       break;
       }
       case NODECL_MULTI_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_multi_expression(child_0, child_1, symbol, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_UNKNOWN:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_unknown(location);
       break;
       }
       case NODECL_FORTRAN_ALTERNATE_RETURN_ARGUMENT:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_alternate_return_argument(symbol, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_RANGE_DISCRETE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_range_discrete(child_0, location);
       break;
       }
       case NODECL_FORTRAN_WHERE_PAIR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_where_pair(child_0, child_1, location);
       break;
       }
       case NODECL_GXX_TRAIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_gxx_trait(child_0, child_1, type, text, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ANALYSIS_INDUCTION_VAR_EXPR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_induction_var_expr(child_0, child_1, child_2, child_3, location);
       break;
       }
       case NODECL_OPEN_M_P_COMBINED_WITH_PARALLEL:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_combined_with_parallel(location);
       break;
       }
       case NODECL_OPEN_M_P_FUNCTION_TASK_PARSING_CONTEXT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_function_task_parsing_context(child_0, location);
       break;
       }
       case NODECL_OMP_SS_TASK_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_task_expression(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_OPEN_M_P_NUM_TASKS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_num_tasks(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_GRAINSIZE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_grainsize(child_0, location);
       break;
       }
       case NODECL_OMP_SS_CHUNKSIZE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_chunksize(child_0, location);
       break;
       }
       case NODECL_CONDITIONAL_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_conditional_expression(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_REFERENCE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_reference(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_COMMA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_comma(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_THROW:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_throw(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VIRTUAL_FUNCTION_CALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_virtual_function_call(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MUL_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_mul_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DIV_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_div_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ADD_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_add_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MINUS_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_minus_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_SHL_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_shl_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_SHR_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_shr_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ARITHMETIC_SHR_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_arithmetic_shr_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_AND_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_and_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_OR_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_or_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_BITWISE_XOR_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_bitwise_xor_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_MOD_ASSIGNMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_mod_assignment(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PREINCREMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_preincrement(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_POSTINCREMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_postincrement(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PREDECREMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_predecrement(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_POSTDECREMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_postdecrement(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_SIZEOF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_sizeof(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_ALIGNOF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_alignof(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_OFFSET:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_offset(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_TYPEID:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_typeid(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_NEW:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_new(child_0, child_1, child_2, child_3, type, text, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DELETE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_delete(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_DELETE_ARRAY:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_delete_array(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_POINTER_TO_MEMBER:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pointer_to_member(symbol, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_REAL_PART:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_real_part(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_IMAG_PART:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_imag_part(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_OFFSETOF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_offsetof(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_SHAPING:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_shaping(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PSEUDO_DESTRUCTOR_NAME:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pseudo_destructor_name(child_0, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VECTOR_CONDITIONAL_EXPRESSION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_conditional_expression(child_0, child_1, child_2, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_VLA_WILDCARD:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vla_wildcard(type, location);
       break;
       }
       case NODECL_GCC_ASM_OPERAND:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_gcc_asm_operand(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_ANALYSIS_ASSERT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_assert(child_0, child_1, location);
       break;
       }
       case NODECL_INTEGER_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_integer_literal(type, cval, location);
       break;
       }
       case NODECL_FLOATING_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_floating_literal(type, cval, location);
       break;
       }
       case NODECL_COMPLEX_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_complex_literal(type, cval, location);
       break;
       }
       case NODECL_BOOLEAN_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_boolean_literal(type, cval, location);
       break;
       }
       case NODECL_OPEN_M_P_DEP_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_dep_in(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_DEP_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_dep_out(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_DEP_INOUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_dep_inout(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_CONCURRENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_concurrent(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_COMMUTATIVE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_commutative(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_reduction(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_WEAK_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_weak_reduction(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_IN_PRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_in_private(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_WEAK_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_weak_in(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_WEAK_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_weak_out(child_0, location);
       break;
       }
       case NODECL_OMP_SS_DEP_WEAK_INOUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_dep_weak_inout(child_0, location);
       break;
       }
       case NODECL_TYPE:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_type(type, location);
       break;
       }
       case NODECL_PRAGMA_CUSTOM_CLAUSE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_pragma_custom_clause(child_0, text, location);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_CXX_DECL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_decl(child_0, symbol, location);
       break;
       }
       case NODECL_CXX_DEF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_def(child_0, symbol, location);
       break;
       }
       case NODECL_CXX_EXPLICIT_INSTANTIATION_DEF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_explicit_instantiation_def(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_CXX_EXPLICIT_INSTANTIATION_DECL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_explicit_instantiation_decl(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_CXX_USING_NAMESPACE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_using_namespace(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_CXX_USING_DECL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_using_decl(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_CXX_PARSE_LATER:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_parse_later(location);
       break;
       }
       case NODECL_CXX_IMPLICIT_INSTANTIATION:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_implicit_instantiation(symbol, location);
       break;
       }
       case NODECL_TEMPLATE_FUNCTION_CODE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_template_function_code(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_VERBATIM:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_verbatim(text, location);
       break;
       }
       case NODECL_FORTRAN_IMPLIED_DO:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_implied_do(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_OMP_SS_ALLOCA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_alloca(child_0, location);
       break;
       }
       case NODECL_OMP_SS_SHARED_AND_ALLOCA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_shared_and_alloca(child_0, location);
       break;
       }
       case NODECL_OMP_SS_WEAK_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_weak_reduction(child_0, location);
       break;
       }
       case NODECL_OMP_SS_COST:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_cost(child_0, location);
       break;
       }
       case NODECL_TRY_BLOCK:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_try_block(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_CXX_FOR_RANGED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_for_ranged(child_0, child_1, symbol, location);
       break;
       }
       case NODECL_CATCH_HANDLER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_catch_handler(child_0, child_1, type, location);
       break;
       }
       case NODECL_CXX_STATIC_ASSERT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_static_assert(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_ALIGNED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_aligned(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_VECTOR_LENGTH:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_vector_length(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_VECTOR_LENGTH_FOR:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_vector_length_for(type, location);
       break;
       }
       case NODECL_OPEN_M_P_UNIFORM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_uniform(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_LINEAR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_linear(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_SUITABLE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_suitable(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_OVERLAP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_overlap(child_0, child_1, child_2, child_3, location);
       break;
       }
       case NODECL_OPEN_M_P_UNROLL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_unroll(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_UNROLL_AND_JAM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_unroll_and_jam(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_NONTEMPORAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_nontemporal(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_PREFETCH:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_prefetch(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_NO_PREFETCH:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_no_prefetch(location);
       break;
       }
       case NODECL_OPEN_M_P_MASK:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_mask(location);
       break;
       }
       case NODECL_OPEN_M_P_NO_MASK:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_no_mask(location);
       break;
       }
       case NODECL_OPEN_M_P_SIMD_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_simd_reduction(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_ASSERT_DECL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_assert_decl(child_0, symbol, location);
       break;
       }
       case NODECL_CXX_CAPTURE_COPY:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_capture_copy(child_0, symbol, location);
       break;
       }
       case NODECL_CXX_CAPTURE_REFERENCE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_capture_reference(child_0, symbol, location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_TEMPLATE_ID:
       {
template_parameter_list_t* template_parameters = nodecl_get_template_parameters(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_template_id(location);
nodecl_set_template_parameters(result, template_parameters);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_IMPLICIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_implicit(location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_BINARY_INFIX:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_binary_infix(location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_UNARY_PREFIX:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_unary_prefix(location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_UNARY_POSTFIX:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_unary_postfix(location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_DEFAULT_INIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_default_init(location);
       break;
       }
       case NODECL_CXX_FUNCTION_FORM_DEFAULT_INIT_BRACED:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_function_form_default_init_braced(location);
       break;
       }
       case NODECL_OPEN_M_P_FOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_for(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_FOR_APPENDIX:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_for_appendix(child_0, child_1, child_2, child_3, location);
       break;
       }
       case NODECL_ASM_DEFINITION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_asm_definition(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_DECLARE_TARGET:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_declare_target(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TASKLOOP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_taskloop(child_0, child_1, location);
       break;
       }
       case NODECL_OMP_SS_RELEASE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_release(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TASK_IS_TASKWAIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_task_is_taskwait(location);
       break;
       }
       case NODECL_OPEN_M_P_TASK_IS_TASKLOOP:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_task_is_taskloop(location);
       break;
       }
       case NODECL_OPEN_M_P_TASK:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_task(child_0, child_1, location);
       break;
       }
       case NODECL_ANALYSIS_REACH_DEF_EXPR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_reach_def_expr(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_BARRIER_AT_END:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_barrier_at_end(location);
       break;
       }
       case NODECL_OPEN_M_P_DEVICE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_device(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MAP_TO:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_map_to(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MAP_FROM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_map_from(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MAP_TO_FROM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_map_to_from(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MAP_ALLOC:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_map_alloc(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MOTION_TO:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_motion_to(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MOTION_FROM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_motion_from(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_NUM_TEAMS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_num_teams(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_THREAD_LIMIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_thread_limit(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TARGET_TASK_UNDEFERRED:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_target_task_undeferred(location);
       break;
       }
       case NODECL_OPEN_M_P_FIRSTPRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_firstprivate(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_LASTPRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_lastprivate(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_FIRST_LASTPRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_first_lastprivate(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_SHARED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_shared(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_THREADPRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_threadprivate(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_PRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_private(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_AUTO:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_auto(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_reduction(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TASK_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_task_reduction(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_IN_REDUCTION:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_in_reduction(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_PRIVATE_INIT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_private_init(child_0, symbol, location);
       break;
       }
       case NODECL_FORTRAN_ALLOCATE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_allocate_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_ARITHMETIC_IF_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_arithmetic_if_statement(child_0, child_1, child_2, child_3, location);
       break;
       }
       case NODECL_FORTRAN_ASSIGNED_GOTO_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_assigned_goto_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_OPEN_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_open_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_CLOSE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_close_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_COMPUTED_GOTO_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_computed_goto_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_ALTERNATE_RETURN_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_alternate_return_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_DEALLOCATE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_deallocate_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_IO_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_io_statement(child_0, child_1, text, location);
       break;
       }
       case NODECL_FORTRAN_LABEL_ASSIGN_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_label_assign_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_NULLIFY_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_nullify_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_PRINT_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_print_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_READ_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_read_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_WRITE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_write_statement(child_0, child_1, location);
       break;
       }
       case NODECL_FORTRAN_STOP_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_stop_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_PAUSE_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_pause_statement(child_0, location);
       break;
       }
       case NODECL_FORTRAN_ENTRY_STATEMENT:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_entry_statement(symbol, location);
       break;
       }
       case NODECL_FORTRAN_WHERE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_where(child_0, location);
       break;
       }
       case NODECL_FORTRAN_FORALL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_fortran_forall(child_0, child_1, child_2, location);
       break;
       }
       case NODECL_OPEN_M_P_TARGET_DATA:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_target_data(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_TARGET:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_target(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_TARGET_UPDATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_target_update(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_TEAMS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_teams(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_DISTRIBUTE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_distribute(child_0, child_1, location);
       break;
       }
       case NODECL_MASK_LITERAL:
       {
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_mask_literal(type, cval, location);
       break;
       }
       case NODECL_SOURCE_COMMENT:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_source_comment(text, location);
       break;
       }
       case NODECL_OMP_SS_COPY_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_copy_in(child_0, location);
       break;
       }
       case NODECL_OMP_SS_COPY_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_copy_out(child_0, location);
       break;
       }
       case NODECL_OMP_SS_COPY_INOUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_copy_inout(child_0, location);
       break;
       }
       case NODECL_OMP_SS_N_D_RANGE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_n_d_range(child_0, location);
       break;
       }
       case NODECL_OMP_SS_SH_MEM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_sh_mem(child_0, location);
       break;
       }
       case NODECL_OMP_SS_FILE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_file(child_0, location);
       break;
       }
       case NODECL_OMP_SS_NAME:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_name(child_0, location);
       break;
       }
       case NODECL_OMP_SS_ONTO:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_onto(child_0, location);
       break;
       }
       case NODECL_OMP_SS_IMPLEMENTS:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_implements(child_0, child_1, location);
       break;
       }
       case NODECL_OMP_SS_TARGET:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_target(child_0, child_1, location);
       break;
       }
       case NODECL_OMP_SS_TASK_LABEL:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_task_label(text, location);
       break;
       }
       case NODECL_RANGE_LOOP_CONTROL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_3 = nodecl_deep_copy_rec(nodecl_get_child(n, 3), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_range_loop_control(child_0, child_1, child_2, child_3, location);
       break;
       }
       case NODECL_ITERATOR_LOOP_CONTROL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_iterator_loop_control(child_0, child_1, location);
       break;
       }
       case NODECL_OPEN_M_P_CRITICAL_NAME:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_critical_name(text, location);
       break;
       }
       case NODECL_CXX_DEP_NAME_SIMPLE:
       {
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_name_simple(text, location);
nodecl_set_symbol(result, symbol);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_ANALYSIS_UPPER_EXPOSED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_upper_exposed(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_DEFINED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_defined(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_UNDEFINED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_undefined(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_LIVE_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_live_in(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_LIVE_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_live_out(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_DEAD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_dead(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_REACHING_DEFINITION_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_reaching_definition_in(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_REACHING_DEFINITION_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_reaching_definition_out(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_INDUCTION_VARIABLE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_induction_variable(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_AUTO_SCOPE_FIRSTPRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_auto_scope_firstprivate(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_AUTO_SCOPE_PRIVATE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_auto_scope_private(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_AUTO_SCOPE_SHARED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_auto_scope_shared(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_RANGE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_range(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_AUTO_STORAGE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_auto_storage(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_DEAD:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_dead(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_FP:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_fp(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_P:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_p(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_IN:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_in(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_OUT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_out(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_IN_POINTED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_in_pointed(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_INCOHERENT_OUT_POINTED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_incoherent_out_pointed(child_0, location);
       break;
       }
       case NODECL_ANALYSIS_CORRECTNESS_RACE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_analysis_correctness_race(child_0, location);
       break;
       }
       case NODECL_VECTOR_FUNCTION_CODE:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_vector_function_code(child_0, location);
       break;
       }
       case NODECL_UPC_SYNC_STATEMENT:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_upc_sync_statement(child_0, text, location);
       break;
       }
       case NODECL_CXX_DEP_GLOBAL_NAME_NESTED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_global_name_nested(child_0, location);
nodecl_set_symbol(result, symbol);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_CXX_DEP_NAME_NESTED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
scope_entry_t* symbol = (*synth_symbol_map)->map(*synth_symbol_map, nodecl_get_symbol(n));
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_dep_name_nested(child_0, location);
nodecl_set_symbol(result, symbol);
nodecl_set_type(result, type);
       break;
       }
       case NODECL_UNKNOWN_PRAGMA:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_unknown_pragma(text, location);
       break;
       }
       case NODECL_FIELD_DESIGNATOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_field_designator(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_INDEX_DESIGNATOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const_value_t* cval = const_value_deep_copy(nodecl_get_constant(n), *synth_symbol_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_index_designator(child_0, child_1, type, location);
nodecl_set_constant(result, cval);
       break;
       }
       case NODECL_PREPROCESSOR_LINE:
       {
const char* text = nodecl_get_text(n);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_preprocessor_line(text, location);
       break;
       }
       case NODECL_CXX_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_initializer(child_0, type, location);
       break;
       }
       case NODECL_CXX_BRACED_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_braced_initializer(child_0, type, location);
       break;
       }
       case NODECL_CXX_EQUAL_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_equal_initializer(child_0, type, location);
       break;
       }
       case NODECL_CXX_PARENTHESIZED_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_parenthesized_initializer(child_0, type, location);
       break;
       }
       case NODECL_C99_DESIGNATED_INITIALIZER:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_c99_designated_initializer(child_0, child_1, location);
       break;
       }
       case NODECL_C99_FIELD_DESIGNATOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_c99_field_designator(child_0, location);
       break;
       }
       case NODECL_C99_INDEX_DESIGNATOR:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_c99_index_designator(child_0, location);
       break;
       }
       case NODECL_CXX_VALUE_PACK:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_value_pack(child_0, type, location);
       break;
       }
       case NODECL_CXX_VALUE_PACK_EXPANDED:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
type_t* type = nodecl_get_type(n);
type = type_deep_copy_compute_maps(type, /* dest */ NULL, new_decl_context, symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_cxx_value_pack_expanded(child_0, type, location);
       break;
       }
       case NODECL_OPEN_M_P_IF:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_if(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_FINAL:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_final(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_PRIORITY:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_priority(child_0, location);
       break;
       }
       case NODECL_OPEN_M_P_MERGEABLE:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_mergeable(location);
       break;
       }
       case NODECL_OPEN_M_P_UNTIED:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_untied(location);
       break;
       }
       case NODECL_OMP_SS_WAIT:
       {
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_omp_ss_wait(location);
       break;
       }
       case NODECL_OPEN_M_P_REDUCTION_ITEM:
       {
nodecl_t child_0 = nodecl_deep_copy_rec(nodecl_get_child(n, 0), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_1 = nodecl_deep_copy_rec(nodecl_get_child(n, 1), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
nodecl_t child_2 = nodecl_deep_copy_rec(nodecl_get_child(n, 2), new_decl_context, (*synth_symbol_map), synth_symbol_map, nodecl_deep_copy_map, symbol_deep_copy_map);
const locus_t* location = nodecl_get_locus(n);
result = nodecl_make_open_m_p_reduction_item(child_0, child_1, child_2, location);
       break;
       }

       default:
           { internal_error("Unexpected tree kind '%s'\n", ast_print_node_type(nodecl_get_kind(n))); }
       }

       nodecl_deep_copy_map_add(nodecl_deep_copy_map, n, result);

       return result;
}

